var Something, eventric, example;

eventric = require('eventric');

example = eventric.context('Example');

Something = (function() {
  function Something() {}

  Something.prototype.create = function() {
    return this.$emitDomainEvent('SomethingCreated', {});
  };

  Something.prototype.modify = function() {
    return this.$emitDomainEvent('SomethingModified', {});
  };

  return Something;

})();

example.addAggregate('Something', Something);

example.defineDomainEvent('SomethingCreated', function() {});

example.defineDomainEvent('SomethingModified', function() {});

example.addCommandHandlers({
  CreateSomething: function() {
    return this.$aggregate.create('Something').then(function(aggregate) {
      return aggregate.$save();
    });
  },
  ModifySomething: function(params) {
    return this.$aggregate.load('Something', params.id).then(function(aggregate) {
      aggregate.modify();
      return aggregate.$save();
    });
  }
});

module.exports = example;
