// Generated by CoffeeScript 1.7.1
(function() {
  var SocketIORemoteEndpoint,
    __slice = [].slice;

  SocketIORemoteEndpoint = (function() {
    function SocketIORemoteEndpoint() {}

    SocketIORemoteEndpoint.prototype.initialize = function(options, callback) {
      if (options == null) {
        options = {};
      }
      if (callback == null) {
        callback = function() {};
      }
      if (options.ioInstance) {
        this._io = options.ioInstance;
      } else {
        this._io = require('socket.io')();
        this._io.listen(3000);
      }
      this._io.sockets.on('connection', (function(_this) {
        return function(socket) {
          socket.on('RPC_Request', function(RPC_Request) {
            return _this._handleRPCRequest(RPC_Request, function(err, response) {
              var rpcId;
              rpcId = RPC_Request.rpcId;
              return socket.emit('RPC_Response', {
                rpcId: rpcId,
                err: err,
                data: response
              });
            });
          });
          socket.on('JoinRoom', function(roomName) {
            return socket.join(roomName);
          });
          return socket.on('LeaveRoom', function(roomName) {
            return socket.leave(roomName);
          });
        };
      })(this));
      return callback();
    };

    SocketIORemoteEndpoint.prototype.close = function() {
      return this._io.engine.close();
    };

    SocketIORemoteEndpoint.prototype.setRPCHandler = function(_handleRPCRequest) {
      this._handleRPCRequest = _handleRPCRequest;
    };

    SocketIORemoteEndpoint.prototype.publish = function() {
      var aggregateId, context, domainEventName, fullEventName, payload, _arg, _i;
      context = arguments[0], _arg = 3 <= arguments.length ? __slice.call(arguments, 1, _i = arguments.length - 1) : (_i = 1, []), payload = arguments[_i++];
      domainEventName = _arg[0], aggregateId = _arg[1];
      fullEventName = this._getFullEventName(context, domainEventName, aggregateId);
      return this._io.to(fullEventName).emit(fullEventName, payload);
    };

    SocketIORemoteEndpoint.prototype._getFullEventName = function(context, domainEventName, aggregateId) {
      var fullEventName;
      fullEventName = context;
      if (domainEventName) {
        fullEventName += "/" + domainEventName;
      }
      if (aggregateId) {
        fullEventName += "/" + aggregateId;
      }
      return fullEventName;
    };

    return SocketIORemoteEndpoint;

  })();

  module.exports = new SocketIORemoteEndpoint;

}).call(this);
